package userkindboxreqservice

import (
	"context"

	param "git.gocasts.ir/ebhomengo/niki/param/benefactor/kind_box_req"
	errmsg "git.gocasts.ir/ebhomengo/niki/pkg/err_msg"
	richerror "git.gocasts.ir/ebhomengo/niki/pkg/rich_error"
)

func (s Service) Get(ctx context.Context, req param.KindBoxReqGetRequest) (param.KindBoxReqGetResponse, error) {
	const op = "userkindboxreqservice.Get"

	kindBoxReq, err := s.repo.GetKindBoxReq(ctx, req.KindBoxReqID)
	if err != nil {
		return param.KindBoxReqGetResponse{}, richerror.New(op).WithErr(err).WithKind(richerror.KindUnexpected)
	}
	// TODO : ref to service.Update()
	if kindBoxReq.BenefactorID != req.BenefactorID {
		return param.KindBoxReqGetResponse{}, richerror.New(op).WithMessage(errmsg.ErrorMsgUserNotAllowed).WithKind(richerror.KindForbidden)
	}

	return param.KindBoxReqGetResponse{KindBoxReq: kindBoxReq}, nil
}
